/*  

    Panda -  A modular programming language.
    written by Giovanni Petrantoni.
    Copyright (c) 2003 - 2004, Giovanni Petrantoni.
    http://xpanda.sf.net/
    
    panda_drivers.h - Panda drivers API
    
    This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.


	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
	Lesser General Public License for more details.


	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
	
	elementicaotici - by Johnny (Giovanni) Petrantoni, ITALY - Rome.
	e-mail: johnny@lato-b.com
	
*/


#include <Panda/panda_modules.h>

typedef struct _driver_parametersList {
	int manyParameters;
	char **parameterDesc; 
	int *parameterType;
	int *parameterID;
}DriverParamList;

#ifdef __cplusplus
extern "C" {
#endif

extern void doPandaRender(long nframes);
extern void setDAC(float **buffers);
extern void setADC(float **buffers);
extern void SetPandaBufferSize(long newNFrames);
extern void SetPandaSampleRate(float newSR);
extern void SetPandaInChannels(int inChannels);
extern void SetPandaOutChannels(int outChannels);

#ifdef __cplusplus
}
#endif

//REQUIRED METHODS
#ifdef __cplusplus
extern "C" {
#endif

/*
	1 open the driver;
	2 get parameters specifications;
	3 set parameters;
	4 create audio engine;
*/

MyData * HelloPandaDriver (void);
int SetParameter (MyData *x,int parameter, Var *inValues);
int GetParameter(MyData *x,int parameter,Var *outValues);
int CreateAudioEngine(MyData *x);
int StartAudio(MyData *x);
int StopAudio(MyData *x);
DriverParamList GetParametersList (MyData *x);
void FlushDriver (MyData *x);

#ifdef __cplusplus
}
#endif

