/*  

    Panda -  A modular programming language.
    written by Giovanni Petrantoni.
    Copyright (c) 2003 - 2004, Giovanni Petrantoni.
    http://xpanda.sf.net/
    
    variables.h - Panda variables utilities
    
    This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.


	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
	Lesser General Public License for more details.


	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
	
	elementicaotici - by Johnny (Giovanni) Petrantoni, ITALY - Rome.
	e-mail: johnny@lato-b.com
	
*/

#ifdef __cplusplus
extern "C" {
#endif

void * NewVarList(int length);

void DeleteVarList(void *list);

void AddToVarListAtIndex(void *list,void *inVar, int index);

void * varFromListAtIndex(void *list,int index);

int manyVars(void *list);

void * NewVarArray(int type,int length);

void * NewVar(int type);

void DeleteVar(void *varP);

int type(void *varP);

int length(void *varP);

char *specifications(void *varP);

void setSpecifications(void *varP,char *specs);

void setIntValue(void *varP,int value);

void setIntValueAtIndex(void *varP,int value,int index);

void setCharValue(void *varP,char value);

void setCharValueAtIndex(void *varP,char value,int index);

void setStringValue(void *varP,char *value);

void setFloatValue(void *varP,float value);

void setFloatValueAtIndex(void *varP,float value,int index);

void setDoubleValue(void *varP,double value);

void setDoubleValueAtIndex(void *varP,double value,int index);

void setShortValue(void *varP,short value);

void setShortValueAtIndex(void *varP,short value,int index);

void setULongValue(void *varP,unsigned long value);

void setULongValueAtIndex(void *varP,unsigned long value,int index);

void setLongValue(void *varP,long value);

void setLongValueAtIndex(void *varP,long value,int index);

void setLDoubleValue(void *varP,long double value);

void setLDoubleValueAtIndex(void *varP,long double value,int index);

void setObjectValue(void *varP,void *value);

void setPtrValue(void *varP,void *value);

int intValue(void *varP);

int intValueAtIndex(void *varP,int index);

char charValue(void *varP);

char charValueAtIndex(void *varP,int index);

char * stringValue(void *varP);

float floatValue(void *varP);

float floatValueAtIndex(void *varP,int index);

double doubleValue(void *varP);

double doubleValueAtIndex(void *varP,int index);

short shortValue(void *varP);

short shortValueAtIndex(void *varP,int index);

unsigned long uLongValue(void *varP);

unsigned long uLongValueAtIndex(void *varP,int index);

long longValue(void *varP);

long longValueAtIndex(void *varP,int index);

long double lDoubleValue(void *varP);

long double lDoubleValueAtIndex(void *varP,int index);

void * objectValue(void *varP);

void * ptrValue(void *varP);


#ifdef __cplusplus
}
#endif

